Index: /packaging/Makefile.packages
===================================================================
--- /packaging/Makefile.packages	(revision 736)
+++ /packaging/Makefile.packages	(revision 737)
@@ -99,4 +99,14 @@
 	pkg.readme=6
 
+# create another WPI with no XWorkplace dependency, see #146
+wpi.lib_noxwpdep.PATH 		= $(OUT_ROOT)/qt-lib-$(QT_VER_FULL)-noxwpdep.wpi
+wpi.lib_noxwpdep.SCRIPT      = $(WPI_ROOT)/lib_noxwpdep.wis
+wpi.lib_noxwpdep.PACKAGES 	= \
+	pkg.lib.runtime=1 \
+	pkg.lib.instutils=2 \
+	pkg.lib.plugins=3 \
+	pkg.lib.translations=4 \
+	pkg.readme=6
+
 #
 # Development archive
@@ -198,5 +208,5 @@
 #
 
-WPIS = wpi.lib wpi.dev wpi.examples wpi.doc
+WPIS = wpi.lib wpi.lib_noxwpdep wpi.dev wpi.examples wpi.doc
 
 #-------------------------------------------------------------------------------
Index: /packaging/lib.wis.tpl
===================================================================
--- /packaging/lib.wis.tpl	(revision 736)
+++ /packaging/lib.wis.tpl	(revision 737)
@@ -99,73 +99,4 @@
 </REXX>
 
-<REXX NAME="GetPkgPathRefFixed">
-    parse arg aPkgIdUtf8', 'aPkgIdLocal
-    ver = GetPkgVersion(aPkgIdUtf8)
-    if (ver == '') then return 'Unable to determine the installation path'
-    return '$('aPkgIdLocal')'
-
-    /* same as above... */
-    GetPkgVersion: procedure
-        parse arg aPkgId
-        rc = rxFuncAdd('SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs')
-        rc = SysLoadFuncs()
-        WarpInDir = strip(SysIni('USER', 'WarpIN', 'Path'), 'T', '0'x)
-        if (WarpInDir \== '') then do
-            rc = SysFileTree(WarpInDir'\DATBAS_?.INI', 'inis', 'FO')
-            if (rc == 0) then do
-                do i = 1 to inis.0
-                    rc = SysIni(inis.i, 'ALL:', 'apps')
-                    if (rc == '') then do
-                        do j = 1 to apps.0
-                            apps.j = strip(apps.j, 'T', '0'x)
-                            if (left(apps.j, length(aPkgId)) == aPkgId) then do
-                                /* found the app */
-                                ver = right(apps.j, length(apps.j) - length(aPkgId) - 1)
-                                ver = translate(ver, '.', '\')
-                                return ver
-                            end
-                        end
-                    end
-                end
-            end
-        end
-        return ''
-</REXX>
-
-<REXX NAME="GetPkgSelectAttrFixed">
-    /* makes sure the package is selected only if the prerequisite is present */
-    parse arg aPkgId
-    ver = GetPkgVersion(aPkgId)
-    if (ver == '') then return ''
-    return 'SELECT'
-
-    /* same as above... */
-    GetPkgVersion: procedure
-        parse arg aPkgId
-        rc = rxFuncAdd('SysLoadFuncs', 'REXXUTIL', 'SysLoadFuncs')
-        rc = SysLoadFuncs()
-        WarpInDir = strip(SysIni('USER', 'WarpIN', 'Path'), 'T', '0'x)
-        if (WarpInDir \== '') then do
-            rc = SysFileTree(WarpInDir'\DATBAS_?.INI', 'inis', 'FO')
-            if (rc == 0) then do
-                do i = 1 to inis.0
-                    rc = SysIni(inis.i, 'ALL:', 'apps')
-                    if (rc == '') then do
-                        do j = 1 to apps.0
-                            apps.j = strip(apps.j, 'T', '0'x)
-                            if (left(apps.j, length(aPkgId)) == aPkgId) then do
-                                /* found the app */
-                                ver = right(apps.j, length(apps.j) - length(aPkgId) - 1)
-                                ver = translate(ver, '.', '\')
-                                return ver
-                            end
-                        end
-                    end
-                end
-            end
-        end
-        return ''
-</REXX>
-
 <REXX NAME="AskToUninstallPreviousVersion">
     call WirexxShowMessage ,
@@ -219,13 +150,13 @@
 >Contains translations of the Qt runtime. This package is recommended</PCK>
 
-<PCK INDEX=5
+<${disable_tag_begin}PCK INDEX=5
      PACKAGEID="netlabs.org\Qt4\SysTray\${version_path}"
      TITLE="Extended System Tray widget for XCenter"
-     =("GetPkgSelectAttrFixed Ulrich MÃ¶ller\XWorkplace\Kernel")
+     SELECT
      REQUIRES="1"
      REQUIRES="Ulrich Mller\XWorkplace\Kernel\0\9\9"
-     TARGET="=("GetPkgPathRefFixed Ulrich MÃ¶ller\XWorkplace\Kernel, Ulrich Mller\XWorkplace\Kernel")" FIXED
-     LONGFILENAMES
->Provides support for the system tray to Qt applications. This package is recommended</PCK>
+     TARGET="$(Ulrich Mller\XWorkplace\Kernel)" FIXED
+     LONGFILENAMES
+>Provides support for the system tray to Qt applications. This package is recommended</PCK${disable_tag_end}>
 
 <PCK INDEX=6
@@ -302,5 +233,5 @@
 
 
-<PAGE INDEX=5 TYPE=TEXT>
+<${disable_tag_begin}PAGE INDEX=5 TYPE=TEXT>
 <NEXTBUTTON TARGET=0>I~nstall</NEXTBUTTON>
 <TEXT>Press "Install" to begin installing the Qt 4 Runtime Libraries.
@@ -310,5 +241,10 @@
 To do so, restart XCenter and select "Create new widget" > "Extended system tray" from the XCenter context menu.
 </TEXT>
-</PAGE>
+</PAGE${disable_tag_end}>
+
+<${enable_tag_begin}PAGE INDEX=5 TYPE=TEXT>
+<NEXTBUTTON TARGET=0>I~nstall</NEXTBUTTON>
+<TEXT>Press "Install" to begin installing the Qt 4 Runtime Libraries.</TEXT>
+</PAGE${enable_tag_end}>
 
 <!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
Index: /packaging/make_packages.cmd
===================================================================
--- /packaging/make_packages.cmd	(revision 736)
+++ /packaging/make_packages.cmd	(revision 737)
@@ -331,7 +331,30 @@
     G.vars.4.v = G.QtInstallPrefix
 
+    G.vars.5 = 'disable_tag_begin';
+    G.vars.5.v = ''
+
+    G.vars.6 = 'disable_tag_end';
+    G.vars.6.v = ''
+
+    G.vars.7 = 'enable_tag_begin';
+    G.vars.7.v = '!--'
+
+    G.vars.8 = 'enable_tag_end';
+    G.vars.8.v = '--'
+
+    G.vars.0 = 8
+
+    call ReplaceInFile 'lib.wis.tpl', G.OutDirWpi'\lib.wis', 'G.vars'
+
+    /* disable the xsystray package and create another WPI, see #146 */
+    G.vars.5.v = '!--'
+    G.vars.6.v = '--'
+    G.vars.7.v = ''
+    G.vars.8.v = ''
+    call ReplaceInFile 'lib.wis.tpl', G.OutDirWpi'\lib_noxwpdep.wis', 'G.vars'
+
+    /* other archives don't need "disable_tag_*" and friends */
     G.vars.0 = 4
 
-    call ReplaceInFile 'lib.wis.tpl', G.OutDirWpi'\lib.wis', 'G.vars'
     call ReplaceInFile 'dev.wis.tpl', G.OutDirWpi'\dev.wis', 'G.vars'
     call ReplaceInFile 'examples.wis.tpl', G.OutDirWpi'\examples.wis', 'G.vars'
@@ -342,4 +365,6 @@
     /* create the .WPI packages */
     if (Exec('make -f Makefile.packages wpi.lib', G.ScriptDir, '>'G.LogFile) \= 0) then
+        call Done 1
+    if (Exec('make -f Makefile.packages wpi.lib_noxwpdep', G.ScriptDir, '>'G.LogFile) \= 0) then
         call Done 1
     if (Exec('make -f Makefile.packages wpi.dev', G.ScriptDir, '>'G.LogFile) \= 0) then