Index: trunk/src/emx/include/sys/stat.h
===================================================================
--- trunk/src/emx/include/sys/stat.h	(revision 743)
+++ trunk/src/emx/include/sys/stat.h	(revision 744)
@@ -1,92 +1,358 @@
-/* sys/stat.h (emx+gcc) */
-
-#ifndef _SYS_STAT_H
-#define _SYS_STAT_H
-
-#if !defined (_SYS_TYPES_H)
- #warning <sys/stat.h> requires <sys/types.h>
-#include <sys/types.h>
-#endif
-
-#if defined (__cplusplus)
-extern "C" {
-#endif
-
-#if !defined (_STAT)
-#define _STAT
-struct stat
-{
-  dev_t   st_dev;
-  ino_t   st_ino;
-  mode_t  st_mode;
-  nlink_t st_nlink;
-  uid_t   st_uid;
-  gid_t   st_gid;
-  dev_t   st_rdev;
-  off_t   st_size;
-  time_t  st_atime;
-  time_t  st_mtime;
-  time_t  st_ctime;
-  long    st_attr;
-  long    st_reserved;
+/*-
+ * Copyright (c) 1982, 1986, 1989, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ * (c) UNIX System Laboratories, Inc.
+ * All or some portions of this file are derived from material licensed
+ * to the University of California by American Telephone and Telegraph
+ * Co. or Unix System Laboratories, Inc. and are reproduced herein with
+ * the permission of UNIX System Laboratories, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)stat.h	8.12 (Berkeley) 6/16/95
+ * $FreeBSD: src/sys/sys/stat.h,v 1.37 2003/05/22 17:07:57 mike Exp $
+ */
+
+/** @file
+ * FreeBSD 5.1
+ * @changed	bird: EMX isms and hid the BSD specific structs and related stuff.
+ */
+
+#ifndef _SYS_STAT_H_
+#define	_SYS_STAT_H_
+
+#include <sys/cdefs.h>
+#include <sys/_types.h>
+
+/* XXX missing blkcnt_t, blksize_t. */
+
+#ifndef _DEV_T_DECLARED
+typedef	__dev_t		dev_t;
+#define	_DEV_T_DECLARED
+#endif
+
+#ifndef _FFLAGS_T_DECLARED
+typedef	__fflags_t	fflags_t;
+#define	_FFLAGS_T_DECLARED
+#endif
+
+#if !defined(_GID_T_DECLARED) && !defined(_GID_T)
+typedef	__gid_t		gid_t;
+#define	_GID_T_DECLARED
+#define	_GID_T
+#endif
+
+#if !defined(_INO_T_DECLARED) && !defined(_INO_T) /* bird: emx */
+typedef	__ino_t		ino_t;
+#define	_INO_T_DECLARED
+#define _INO_T                          /* bird: emx */
+#endif
+
+#if !defined(_MODE_T_DECLARED) && !defined(_MODE_T) /* bird: emx */
+typedef	__mode_t	mode_t;
+#define	_MODE_T_DECLARED
+#define _MODE_T                         /* bird: emx */
+#endif
+
+#ifndef _NLINK_T_DECLARED
+typedef	__nlink_t	nlink_t;
+#define	_NLINK_T_DECLARED
+#endif
+
+#if !defined(_OFF_T_DECLARED) && !defined(_OFF_T) /* bird: emx */
+typedef	__off_t		off_t;
+#define	_OFF_T_DECLARED
+#define _OFF_T                          /* bird: emx */
+#endif
+
+#if !defined(_TIME_T_DECLARED) && !defined(_TIME_T) /* bird: emx */
+typedef	__time_t	time_t;
+#define	_TIME_T_DECLARED
+#define _TIME_T                         /* bird: emx */
+#endif
+
+#if !defined(_UID_T_DECLARED) && !defined(_UID_T) /* bird: emx */
+typedef	__uid_t		uid_t;
+#define	_UID_T_DECLARED
+#define _UID_T                          /* bird: emx */
+#endif
+
+#if !defined(_KERNEL) && __BSD_VISIBLE
+/*
+ * XXX we need this for struct timespec.  We get miscellaneous namespace
+ * pollution with it.
+ */
+#include <sys/time.h>
+#endif
+
+#if !__BSD_VISIBLE
+#include <sys/_timespec.h>
+#endif
+
+#if 0  /* bird: emx */
+#if __BSD_VISIBLE
+struct ostat {
+	__uint16_t st_dev;		/* inode's device */
+	ino_t	  st_ino;		/* inode's number */
+	mode_t	  st_mode;		/* inode protection mode */
+	nlink_t	  st_nlink;		/* number of hard links */
+	__uint16_t st_uid;		/* user ID of the file's owner */
+	__uint16_t st_gid;		/* group ID of the file's group */
+	__uint16_t st_rdev;		/* device type */
+	__int32_t st_size;		/* file size, in bytes */
+	struct	timespec st_atimespec;	/* time of last access */
+	struct	timespec st_mtimespec;	/* time of last data modification */
+	struct	timespec st_ctimespec;	/* time of last file status change */
+	__int32_t st_blksize;		/* optimal blocksize for I/O */
+	__int32_t st_blocks;		/* blocks allocated for file */
+	fflags_t  st_flags;		/* user defined flags for file */
+	__uint32_t st_gen;		/* file generation number */
 };
-#endif
-
-#if !defined (S_IRUSR)
-#define S_IRWXU 00700
-#define S_IRUSR 00400
-#define S_IWUSR 00200
-#define S_IXUSR 00100
-
-#define S_IRWXG 00070
-#define S_IRGRP 00040
-#define S_IWGRP 00020
-#define S_IXGRP 00010
-
-#define S_IRWXO 00007
-#define S_IROTH 00004
-#define S_IWOTH 00002
-#define S_IXOTH 00001
-
-#define	S_ISGID 02000
-#define	S_ISUID 04000
-#endif
-
-#if !defined (S_IFMT)
-#define S_IFMT   0170000  /* Mask for file type */
-#define S_IFIFO  0010000  /* Pipe */
-#define S_IFCHR  0020000  /* Character device */
-#define S_IFDIR  0040000  /* Directory */
-#define S_IFREG  0100000  /* Regular file */
-#define S_IFSOCK 0140000  /* Socket */
-
-/* S_ISBLK */
-#define S_ISCHR(mode)  (((mode) & S_IFMT) == S_IFCHR)
-#define S_ISDIR(mode)  (((mode) & S_IFMT) == S_IFDIR)
-#define S_ISREG(mode)  (((mode) & S_IFMT) == S_IFREG)
-#define S_ISFIFO(mode) (((mode) & S_IFMT) == S_IFIFO)
-#define S_ISSOCK(mode) (((mode) & S_IFMT) == S_IFSOCK)
-#endif
-
-int chmod (__const__ char *, int);
-int fstat (int, struct stat *);
-int mkdir (__const__ char *, long);
-/* mkfifo() */
-int stat (__const__ char *, struct stat *);
-int umask (int);
-
-
-#if !defined (_POSIX_SOURCE)
-
-#if !defined (S_IREAD)
-#define S_IREAD  0400     /* Owner: read */
-#define S_IWRITE 0200     /* Owner: write */
-#define S_IEXEC  0100     /* Owner: exec */
-#endif
-
-#endif
-
+#endif /* __BSD_VISIBLE */
+#endif /* bird: emx */
+
+struct stat {
+	__udev_t  st_dev;		/* inode's device */
+	ino_t	  st_ino;		/* inode's number */
+	mode_t	  st_mode;		/* inode protection mode */
+	nlink_t	  st_nlink;		/* number of hard links */
+	uid_t	  st_uid;		/* user ID of the file's owner */
+	gid_t	  st_gid;		/* group ID of the file's group */
+	__udev_t  st_rdev;		/* device type */
+#if 1 /* bird: emx */
+	time_t	  st_atime;
+	time_t	  st_mtime;
+	time_t	  st_ctime;
+#else /* bird: emx */
+#if __BSD_VISIBLE
+	struct	timespec st_atimespec;	/* time of last access */
+	struct	timespec st_mtimespec;	/* time of last data modification */
+	struct	timespec st_ctimespec;	/* time of last file status change */
+#else
+	time_t	  st_atime;		/* time of last access */
+	long	  st_atimensec;		/* nsec of last access */
+	time_t	  st_mtime;		/* time of last data modification */
+	long	  st_mtimensec;		/* nsec of last data modification */
+	time_t	  st_ctime;		/* time of last file status change */
+	long	  st_ctimensec;		/* nsec of last file status change */
+#endif
+#endif /* bird: emx */
+	off_t	  st_size;		/* file size, in bytes */
+	__int64_t st_blocks;		/* blocks allocated for file */
+	__uint32_t st_blksize;		/* optimal blocksize for I/O */
+#if 1 /* bird: emx: */
+	long	  st_attr;		/* emx: OS/2 & DOS attributes */
+	long	  st_reserved;
+#else /* bird: emx */
+
+	fflags_t  st_flags;		/* user defined flags for file */
+	__uint32_t st_gen;		/* file generation number */
+	__int32_t st_lspare;
+#if __BSD_VISIBLE
+	struct timespec st_birthtimespec; /* time of file creation */
+	/*
+	 * Explicitly pad st_birthtimespec to 16 bytes so that the size of
+	 * struct stat is backwards compatible.  We use bitfields instead
+	 * of an array of chars so that this doesn't require a C99 compiler
+	 * to compile if the size of the padding is 0.  We use 2 bitfields
+	 * to cover up to 64 bits on 32-bit machines.  We assume that
+	 * CHAR_BIT is 8...
+	 */
+	unsigned int :(8 / 2) * (16 - (int)sizeof(struct timespec));
+	unsigned int :(8 / 2) * (16 - (int)sizeof(struct timespec));
+#else
+	time_t	  st_birthtime;		/* time of file creation */
+	long	  st_birthtimensec;	/* nsec of file creation */
+	unsigned int :(8 / 2) * (16 - (int)sizeof(struct __timespec));
+	unsigned int :(8 / 2) * (16 - (int)sizeof(struct __timespec));
+#endif
+#endif /* bird: emx - end */
+};
+
+#if 0  /* bird: emx */
+#if __BSD_VISIBLE
+struct nstat {
+	__udev_t st_dev;		/* inode's device */
+	ino_t	  st_ino;		/* inode's number */
+	__uint32_t st_mode;		/* inode protection mode */
+	__uint32_t st_nlink;		/* number of hard links */
+	uid_t	  st_uid;		/* user ID of the file's owner */
+	gid_t	  st_gid;		/* group ID of the file's group */
+	__udev_t st_rdev;		/* device type */
+	struct	timespec st_atimespec;	/* time of last access */
+	struct	timespec st_mtimespec;	/* time of last data modification */
+	struct	timespec st_ctimespec;	/* time of last file status change */
+	off_t	  st_size;		/* file size, in bytes */
+	__int64_t st_blocks;		/* blocks allocated for file */
+	__uint32_t st_blksize;		/* optimal blocksize for I/O */
+	fflags_t  st_flags;		/* user defined flags for file */
+	__uint32_t st_gen;		/* file generation number */
+	struct timespec st_birthtimespec; /* time of file creation */
+	/*
+	 * See above about the following padding.
+	 */
+	unsigned int :(8 / 2) * (16 - (int)sizeof(struct timespec));
+	unsigned int :(8 / 2) * (16 - (int)sizeof(struct timespec));
+};
+#endif
+#endif /* bird: emx */
+
+#if 0  /* bird: emx */
+#if __BSD_VISIBLE
+#define st_atime st_atimespec.tv_sec
+#define st_mtime st_mtimespec.tv_sec
+#define st_ctime st_ctimespec.tv_sec
+#define st_birthtime st_birthtimespec.tv_sec
+#endif
+#endif /* bird: emx */
+
+#define	S_ISUID	0004000			/* set user id on execution */
+#define	S_ISGID	0002000			/* set group id on execution */
+#if __BSD_VISIBLE
+#define	S_ISTXT	0001000			/* sticky bit */
+#endif
+
+#define	S_IRWXU	0000700			/* RWX mask for owner */
+#define	S_IRUSR	0000400			/* R for owner */
+#define	S_IWUSR	0000200			/* W for owner */
+#define	S_IXUSR	0000100			/* X for owner */
+
+#if __BSD_VISIBLE
+#define	S_IREAD		S_IRUSR
+#define	S_IWRITE	S_IWUSR
+#define	S_IEXEC		S_IXUSR
+#endif
+
+#define	S_IRWXG	0000070			/* RWX mask for group */
+#define	S_IRGRP	0000040			/* R for group */
+#define	S_IWGRP	0000020			/* W for group */
+#define	S_IXGRP	0000010			/* X for group */
+
+#define	S_IRWXO	0000007			/* RWX mask for other */
+#define	S_IROTH	0000004			/* R for other */
+#define	S_IWOTH	0000002			/* W for other */
+#define	S_IXOTH	0000001			/* X for other */
+
+#if __XSI_VISIBLE
+#define	S_IFMT	 0170000		/* type of file mask */
+#define	S_IFIFO	 0010000		/* named pipe (fifo) */
+#define	S_IFCHR	 0020000		/* character special */
+#define	S_IFDIR	 0040000		/* directory */
+#define	S_IFBLK	 0060000		/* block special */
+#define	S_IFREG	 0100000		/* regular */
+#define	S_IFLNK	 0120000		/* symbolic link */
+#define	S_IFSOCK 0140000		/* socket */
+#define	S_ISVTX	 0001000		/* save swapped text even after use */
+#endif
+#if __BSD_VISIBLE
+#define	S_IFWHT  0160000		/* whiteout */
+#endif
+
+#define	S_ISDIR(m)	(((m) & 0170000) == 0040000)	/* directory */
+#define	S_ISCHR(m)	(((m) & 0170000) == 0020000)	/* char special */
+#define	S_ISBLK(m)	(((m) & 0170000) == 0060000)	/* block special */
+#define	S_ISREG(m)	(((m) & 0170000) == 0100000)	/* regular file */
+#define	S_ISFIFO(m)	(((m) & 0170000) == 0010000)	/* fifo or socket */
+#if __POSIX_VISIBLE >= 200112
+#define	S_ISLNK(m)	(((m) & 0170000) == 0120000)	/* symbolic link */
+#define	S_ISSOCK(m)	(((m) & 0170000) == 0140000)	/* socket */
+#endif
+#if __XSI_VISIBLE
+#define	S_ISWHT(m)	(((m) & 0170000) == 0160000)	/* whiteout */
+#endif
+
+#if __BSD_VISIBLE
+#define	ACCESSPERMS	(S_IRWXU|S_IRWXG|S_IRWXO)	/* 0777 */
+							/* 7777 */
+#define	ALLPERMS	(S_ISUID|S_ISGID|S_ISTXT|S_IRWXU|S_IRWXG|S_IRWXO)
+							/* 0666 */
+#define	DEFFILEMODE	(S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH)
+
+#define S_BLKSIZE	512		/* block size used in the stat struct */
+
+/*
+ * Definitions of flags stored in file flags word.
+ *
+ * Super-user and owner changeable flags.
+ */
+#define	UF_SETTABLE	0x0000ffff	/* mask of owner changeable flags */
+#define	UF_NODUMP	0x00000001	/* do not dump file */
+#define	UF_IMMUTABLE	0x00000002	/* file may not be changed */
+#define	UF_APPEND	0x00000004	/* writes to file may only append */
+#define UF_OPAQUE	0x00000008	/* directory is opaque wrt. union */
+#define UF_NOUNLINK	0x00000010	/* file may not be removed or renamed */
+/*
+ * Super-user changeable flags.
+ */
+#define	SF_SETTABLE	0xffff0000	/* mask of superuser changeable flags */
+#define	SF_ARCHIVED	0x00010000	/* file is archived */
+#define	SF_IMMUTABLE	0x00020000	/* file may not be changed */
+#define	SF_APPEND	0x00040000	/* writes to file may only append */
+#define	SF_NOUNLINK	0x00100000	/* file may not be removed or renamed */
+#define	SF_SNAPSHOT	0x00200000	/* snapshot inode */
+
+#ifdef _KERNEL
+/*
+ * Shorthand abbreviations of above.
+ */
+#define	OPAQUE		(UF_OPAQUE)
+#define	APPEND		(UF_APPEND | SF_APPEND)
+#define	IMMUTABLE	(UF_IMMUTABLE | SF_IMMUTABLE)
+#define	NOUNLINK	(UF_NOUNLINK | SF_NOUNLINK)
+#endif
+
+#endif /* __BSD_VISIBLE */
+
+#ifndef _KERNEL
+__BEGIN_DECLS
+#if __BSD_VISIBLE
+/** @todo int	chflags(const char *, unsigned long); */
+#endif
+/** @todo int	chmod(const char *, mode_t); */
+#if __BSD_VISIBLE
+/** @todo int	fchflags(int, unsigned long); */
+/** @todo int	fchmod(int, mode_t); */
+#endif
+int	fstat(int, struct stat *);
+#if __BSD_VISIBLE
+/** @todo int	lchflags(const char *, int); */
+/** @todo int	lchmod(const char *, mode_t); */
+#endif
+#if __POSIX_VISIBLE >= 200112
+int	lstat(const char *, struct stat *);
+#endif
+int	mkdir(const char *, mode_t);
+/** @todo int	mkfifo(const char *, mode_t); */
+int	stat(const char *, struct stat *);
+mode_t	umask(mode_t);
+
+/* bird: emx stuff - start */
 #if !defined (_POSIX_SOURCE) || defined (_WITH_UNDERSCORE)
-
 int _chmod (__const__ char *, int);
 int _fstat (int, struct stat *);
@@ -95,10 +361,10 @@
 int _stat (__const__ char *, struct stat *);
 int _umask (int);
-
-#endif
-
-#if defined (__cplusplus)
-}
-#endif
-
-#endif /* not SYS_STAT_H */
+#endif
+/* bird: emx stuff - end */
+
+__END_DECLS
+#endif /* !_KERNEL */
+
+#endif /* !_SYS_STAT_H_ */
+
Index: trunk/src/emx/src/lib/libc.def
===================================================================
--- trunk/src/emx/src/lib/libc.def	(revision 743)
+++ trunk/src/emx/src/lib/libc.def	(revision 744)
@@ -816,2 +816,3 @@
     "__std_ftello" @835
     "__std_readdir_r" @836
+    "__std_lstat" @837
Index: trunk/src/emx/src/lib/sys/__fstat.c
===================================================================
--- trunk/src/emx/src/lib/sys/__fstat.c	(revision 743)
+++ trunk/src/emx/src/lib/sys/__fstat.c	(revision 744)
@@ -92,4 +92,5 @@
         {
             pStat->st_size = info.fsts3L.cbFile;
+            pStat->st_blocks = info.fsts3L.cbFileAlloc / S_BLKSIZE;
             rc = info.fsts3L.attrFile;
         }
@@ -98,4 +99,5 @@
         {
             pStat->st_size = info.fsts3.cbFile;
+            pStat->st_blocks = info.fsts3.cbFileAlloc / S_BLKSIZE;
             rc = info.fsts3.attrFile;
         }
@@ -130,5 +132,5 @@
     pStat->st_rdev = 0;
     pStat->st_nlink = 1;
-    pStat->st_reserved = 0;             /* what is this good for?!? */
+    pStat->st_blksize = 4096*48;
     return 0;
 }
Index: trunk/src/emx/src/lib/sys/__stat.c
===================================================================
--- trunk/src/emx/src/lib/sys/__stat.c	(revision 743)
+++ trunk/src/emx/src/lib/sys/__stat.c	(revision 744)
@@ -90,8 +90,14 @@
 #if OFF_MAX > LONG_MAX
         if (fLarge)
+        {
             pStat->st_size = info.fsf3L.cbFile;
+            pStat->st_blocks = info.fsts3L.cbFileAlloc / S_BLKSIZE;
+        }
         else
 #endif
+        {
             pStat->st_size = info.fsts3.cbFile;
+            pStat->st_blocks = info.fsts3.cbFileAlloc / S_BLKSIZE;
+        }
         pStat->st_mode = S_IFREG;
         if (rc & FILE_READONLY)
@@ -110,4 +116,5 @@
     pStat->st_nlink = 1;
     pStat->st_reserved = 0;             /* what is this good for?!? */
+    pStat->st_blksize = 4096*48;
     return 0;
 }